%global pkg dinghai
%define pkg_version 2.24.20.02
%define release 5

%global debug_package %{nil}

Name:        kmod-%{pkg} 
Version:     %{pkg_version}
Release:     %{release}%{?dist}
Summary:     ZTE SmartNIC and DPU driver
License:     GPLv2
URL:         https://gitee.com/OpenCloudOS/partners-drivers
Source0:     kmod-dinghai.tar.gz
Epoch:       1

# 安装依赖, 和内核版本对应
Requires(posttrans): %{_sbindir}/depmod
Requires(postun):    %{_sbindir}/depmod
Requires(posttrans): %{_sbindir}/weak-modules
Requires(postun):    %{_sbindir}/weak-modules
Requires(posttrans): %{_bindir}/sort
Requires(postun):    %{_bindir}/sort

# 构建依赖, 和内核版本对应
BuildRequires:    elfutils-libelf-devel
BuildRequires:    gcc
BuildRequires:    kmod
BuildRequires:    make
BuildRequires:    system-rpm-config
BuildRequires:    perl-Data-Dumper
BuildRequires:    kernel
BuildRequires:    kernel-headers
BuildRequires:    kernel-devel
BuildRequires:    kernel-core

%define kernel_version %(rpm -qa kernel-devel | sed 's/^kernel-devel-//' | sed 's/.oc8.%{_arch}//')
%define kernel_source /usr/src/kernels/%{kernel_version}

%description
RPM Package for ZXDH Driver

%prep
%autosetup -n kmod-%{pkg} -p1

%build
echo "kernel_version:%{kernel_version}"
pushd crypto/zsda
make -C %{kernel_source} M=$PWD modules CONFIG_ACC_ZSDA_COMMON=m CONFIG_ACC_ZSDA_PF=m CONFIG_ACC_ZSDA_VF=m
popd
pushd net/build
    ./build.pl -t clean --ksrc %{kernel_source}
    ./build.pl -t kernel -m CONFIG_DINGHAI_ETH                -m CONFIG_ZXDH_AUXILIARY -m CONFIG_DINGHAI_PF \
                     -m CONFIG_ZXDH_SF                    -m CONFIG_DINGHAI_EN_AUX \
                     -m HAVE_DEV_PM_DOMAIN_ATTACH         -m HAVE_BUS_FIND_DEVICE_GET_CONST \
                     -m CONFIG_DINGHAI_DH_CMD             -m CONFIG_DINGHAI_NP \
                     -m CONFIG_ZXDH_MSGQ                  -m CONFIG_ZXDH_HARDWARE_BOND \
                     -m CONFIG_DINGHAI_PTP                -m CONFIG_DINGHAI_TSN \
		     -m HAVE_DEVLINK_ALLOC_GET_1_PARAMS --ksrc %{kernel_source}
popd
pushd rdma
./build.sh --ksrc %{kernel_source} --use_rel_net_path
popd

%install
mkdir -p %{buildroot}/lib/modules/%{kernel_version}/extra/drivers/dinghai/crypto/zsda/
mkdir -p %{buildroot}/lib/modules/%{kernel_version}/extra/drivers/dinghai/net/
mkdir -p %{buildroot}/lib/modules/%{kernel_version}/extra/drivers/dinghai/rdma/
for ko in $(find crypto/zsda/accdevice/  net/drivers/ rdma/ -name '*.ko'); do
    if [[ $ko == crypto/zsda/accdevice/* ]]; then
        target_dir=%{buildroot}/lib/modules/%{kernel_version}/extra/drivers/dinghai/crypto/zsda/
    elif [[ $ko == net/drivers/* ]]; then
        target_dir=%{buildroot}/lib/modules/%{kernel_version}/extra/drivers/dinghai/net/
    elif [[ $ko == rdma/* ]]; then
        target_dir=%{buildroot}/lib/modules/%{kernel_version}/extra/drivers/dinghai/rdma/
    fi
    %{__install} -D -t $target_dir $ko
done

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel_version}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
%{__rm} -rf %{buildroot}

%post
depmod -a > /dev/null 2>&1


%preun
list_file="/var/run/rpm-%{pkg}-modules.list"
mkdir -p /var/run
for ko in $(find %{buildroot}/lib/modules/%{kernel_version}/extra/drivers/dinghai/crypto/zsda/ -name '*.ko'); do
    echo "${ko#%{buildroot}}" >> $list_file
done

%postun
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list

%files
%defattr(644,root,root,755)
/lib/modules/%{kernel_version}
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

%changelog
* Thu Sep 12 2024 hcf <han.chengfei@zte.com.cn> - 1:2.24.20.02-5
- [Type] other  
- [DESC] ZTE Dinghai driver init

* Wed Sep 04 2024 hcf <han.chengfei@zte.com.cn> - 1:2.24.20.02-4
- [Type] other 
- [DESC] Modified zsda arm64 support

* Mon Sep 02 2024 hcf <han.chengfei@zte.com.cn> - 1:2.24.20.02-3
- [Type] other 
- [DESC] Modified zsda source code

* Mon Sep 02 2024 hcf <han.chengfei@zte.com.cn> - 1:2.24.20.02-2
- [Type] other
- [DESC] Modify Buildrequires kernel path

* Fri Aug 30 2024 hcf <han.chengfei@zte.com.cn> - 1:2.24.20.02-1
- [Type] other 
- [DESC] Dinghai driver init
